
/*

  Read a state file in the form generated by the original program,
  extracting links at a single specified site.

*/

#include <stdio.h>
#include "datahdr.h"
#include "strmhdr.h"

#define S_SLICE 0
#define S_POINT 1

static char *usage        = "USAGE: ginspect <state> <sites...>\n" ;

void get_params (state, nsites, sites, argc, argv)
char **state ;
int  *nsites, **sites ;
int argc ;
char *argv [] ;
{
  int i ;

  if (argc < 2)
  {
    fprintf (stderr, usage) ;
    exit (1) ;
  }
  *state = argv [1] ;

  *nsites = argc - 2 ;
  *sites  = (int *) malloc (sizeof (int) * (*nsites)) ;
  for (i = 0; i < *nsites; i++)
    (*sites) [i] = atoi (argv [2 + i]) ;
}

void main (argc, argv)
int argc ;
char *argv [] ;
{
  char *state ;
  int nsites, *sites ;
  DATA *datas ;
  int   params [NUM_STT_PARAMS] ;
  float coeffs [NUM_STT_COEFFS] ;
  int l_time, l_space ;

  get_params  (&state, &nsites, &sites, argc, argv) ;

  datas = data_open_read (state) ;
  read_header     (datas) ;
  read_coeffs     (datas, coeffs) ;
  read_params     (datas, params) ;

  l_time  = params [STT_L_T] / params [STT_N_REPS] ;
  l_space = params [STT_L_X] * params [STT_L_Y] * params [STT_L_Z] ;

  read_field_begin  (datas) ;
  print_site (datas, l_time, l_space,
              params [STT_L_X], params [STT_L_Y], params [STT_L_Z],
	      nsites, sites) ;

  data_close_read  (datas) ;
}

